%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                              %
% Englische Grammatik                                                          %
%                                                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Gegeben die folgende Wissensbasis

word(determiner,a).                                            % a ist ein Determiner mit dem Label word.
word(determiner,every).                                        % every ist ein Determiner mit dem Label word.
word(noun,criminal).                                           % criminal ist ein Nomen mit dem Label word.
word(noun,'big  kahuna  burger').                              % big kahunda burger ist ein Nomen mit dem Label word.
word(verb,eats).                                               % eats ist ein Verb mit dem Label word.
word(verb,likes).                                              % likes ist ein Verb mit dem Label word.

sentence(seq(Word1,Word2,Word3,Word4,Word5)):-                 % Ein Satz besteht aus einer Sequenz mit fünf Worten. 
         word(determiner,Word1),                               % Das erste Wort ist ein Determiner.                              
         word(noun,Word2),                                     % Das zweite Wort ist ein Nomen.
         word(verb,Word3),                                     % Das dritte Wort ist ein Verb.
         word(determiner,Word4),                               % Das vierte Wort ist ein Determiner.
         word(noun,Word5).                                     % Das fünfte Wort ist ein Nomen.
         
% Welche Anfrage muss gestellt werden, um grammatisch wohlgeformte Saetze zu
% generieren? (Test)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Loesung

% ?- sentence(X).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                              %
% Deutsche Grammatik                                                           %
%                                                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Schreibe eine Wissensbasis, mit der Saetze generiet werden koennen,
% die aus den folgenden Woertern aufgebaut sind:
% katze
% maus
% die
% eine
% klaut
% jagt
% Wie viele Saetze koennen mit dieser Grammatik generiet werden
% Erweitere die Grammatik um Pluralformen und / oder 
% um Genus erweitert werden?

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Loesung

% Zu dieser Aufgabe gab es viele moegliche Loesungen. Folgend befinden sich drei
% Loesungen: Eine einfache, die nur fuenfstellige Saetze ohne Plural und Maskulina
% generiert, eine mit Numerus und eine umfangreichere mit Genus, Numerus und Kasus.

%%% Loesung Eins: beachtet weder Numerus noch Genus, besteht aus fünf Wörtern
% satz_eins(X).

word_eins(determiner,die).                                     % die ist ein Determiner mit dem Label word_eins.
word_eins(determiner,eine).                                    % eine ist ein Determiner mit dem Label word_eins.
word_eins(noun,katze).                                         % katze ist ein Nomen mit dem Label word_eins.
word_eins(noun,maus).                                          % maus ist ein Nomen mit dem Label word_eins.
word_eins(verb,klaut).                                         % klaut ist ein Verb mit dem Label word_eins.
word_eins(verb,jagt).                                          % jagt ist ein Verb mit dem Label word_eins.

satz_eins(seq(Word1,Word2,Word3,Word4,Word5)):-                % Satz Eins besteht aus einer Sequenz mit fünf Wörtern.
         word_eins(determiner,Word1),                          % Das erste Wort ist ein Determiner.
         word_eins(noun,Word2),                                % Das zweite Wort ist ein Nomen.
         word_eins(verb,Word3),                                % Das dritte Wort ist ein Verb.
         word_eins(determiner,Word4),                          % Das vierte Wort ist ein Determiner.
         word_eins(noun,Word5).                                % Das fünfte Wort ist ein Nomen.

         
%%% Loesung Zwei: beachtet Numerus, besteht aus fünf Wörtern
% satz_zwei(X).

% Hierbei ist wichtig, dass Numerus des Subjekts und Verbs übereinstimmen.
% Das Objekt kann - muss aber nicht - den gleichen Numerus haben.

word_zwei(sg,determiner,die).                                  % die ist ein Determiner im Singular mit dem Label word_zwei.
word_zwei(sg,determiner,eine).                                 % eine ist ein Determiner im Singular mit dem Label word_zwei.
word_zwei(sg,noun,katze).                                      % katze ist ein Nomen im Singular mit dem Label word_zwei.
word_zwei(sg,noun,maus).                                       % maus ist ein Nomen im Singular mit dem Label word_zwei.
word_zwei(sg,verb,klaut).                                      % klaut ist ein Verb im Singular mit dem Label word_zwei.
word_zwei(sg,verb,jagt).                                       % jagt ist ein Verb im Singular mit dem Label word_zwei.


word_zwei(pl,noun,katzen).                                     % katzen ist ein Nomen im Plural mit dem Label word_zwei.
word_zwei(pl,noun,maeuse).                                     % maeuse ist ein Nomen im Plural mit dem Label word_zwei.
word_zwei(pl,verb,klauen).                                     % klauen ist ein Verb im Plural mit dem Label word_zwei.
word_zwei(pl,verb,jagen).                                      % jagen ist ein Verb im Plural mit dem Label word_zwei.
word_zwei(pl,determiner,die).                                  % die ist ein Determiner im Plural mit dem Label word_zwei.
word_zwei(pl,determiner,mehrere).                              % mehrere ist ein Determiner im Plural mit dem Label word_zwei.

satz_zwei(seq(Word1,Word2,Word3,Word4,Word5)):-                % Satz zwei besteht aus einer Sequenz mit fünf Wörtern.
         word_zwei(X,determiner,Word1),                        % Das erste Wort ist ein Determiner mit Numerus X.
         word_zwei(X,noun,Word2),                              % Das zweite Wort ist ein Nomen mit Numerus X.
         word_zwei(X,verb,Word3),                              % Das dritte Wort ist ein Verb mit Numerus X.
         word_zwei(Y,determiner,Word4),                        % Das vierte Wort ist ein Determiner mit Numerus Y.
         word_zwei(Y,noun,Word5).                              % Das fünfte Wort ist ein Nomen mit Numerus Y.


%%% Loesung Drei
% satz_drei(X).

% Numerus, Genus und Kasus werden beachtet und die Saetze
% zusaetzlich noch in Nominal- und Verbalphrasen zerlegt werden

% word_drei(determiner, Wort, Numerus, Genus, Kasus)
% Ein Determinierer hat Numerus, Genus und Kasus.
word_drei(determiner,die,sg,fem,_CASE).                        % die ist ein Determiner im Singular, feminin und beliebigem Kasus mit dem Label word_drei.
word_drei(determiner,eine,sg,fem,_CASE).                       % eine ist ein Determiner im Singular, feminin und beliebigem Kasus mit dem Label word_drei.
word_drei(determiner,der,sg,masc,nom).                         % der ist ein Determiner im Singular, maskulin im Nominatic mit dem Label word_drei.
word_drei(determiner,den,sg,masc,acc).                         % den ist ein Determiner im Singular, maskulin im Akkusativ mit dem Label word_drei.
word_drei(determiner,die,pl,_GEN,_CASE).                       % die ist ein Determiner im Plural, beliebigem Genus und beliebigem Kasus mit dem Label word_drei.

% word_drei(noun, Word, Numerus, Genus, Kasus)
% Ein Nomen hat Numerus, Genus und Kasus.
word_drei(noun,katze,sg,fem,_CASE).                            % katze ist ein Nomen im Singular, feminin und beliebigem Kasus mit dem Label word_drei.
word_drei(noun,katzen,pl,fem,_CASE).                           % katzen ist ein Nomen im Plural, feminin und beliebigem Kasus mit dem Label word_drei.
word_drei(noun,maus,sg,fem,_CASE).                             % maus ist ein Nomen im Singular, feminin und beliebigem Kasus mit dem Label word_drei.
word_drei(noun,maeuse,pl,fem,_CASE).                           % maeuse ist ein Nomen im Plural, feminin und beliebigem Kasus mit dem Label word_drei.
word_drei(noun,hund,sg,masc,_CASE).                            % hund ist ein Nomen im Singular, maskulin und beliebigem Kasus mit dem Label word_drei.
word_drei(noun,hunde,pl,masc,_CASE).                           % hunde ist ein Nomen im Plural, maskulin und beliebigem Kasus mit dem Label word_drei.

% word_drei(verb, Word, Numerus, Kasus)
% Ein transitives Verb hat einen Numerus und eine NP als Argument, die in einem
% bestimmten Kasus stehen muss.
% Oft koennen transitive Verben auch intransitiv verwendet werden, sprich ohne NP (null).

word_drei(verb,jagt,sg,acc).                                   % jagt ist ein Verb im Singluar, einem Argument im Akkusativ und mit dem Label word_drei.
word_drei(verb,jagen,pl,acc).                                  % jagen ist ein Verb im Plural, einem Argument im Akkusativ und mit dem Label word_drei.
word_drei(verb,klaut,sg,acc).                                  % klaut ist ein Verb im Singluar, einem Argument im Akkusativ und mit dem Label word_drei.
word_drei(verb,klauen,pl,acc).                                 % klauen ist ein Verb im Plural, einem Argument im Akkusativ und mit dem Label word_drei.
word_drei(verb,jagt,sg,null).                                  % jagt ist ein Verb im Singluar, ohne Argument und mit dem Label word_drei.
word_drei(verb,jagen,pl,null).                                 % jagen ist ein Verb im Plural, ohne Argument und mit dem Label word_drei.
word_drei(verb,klaut,sg,null).                                 % klaut ist ein Verb im Singluar, ohne Argument und mit dem Label word_drei.
word_drei(verb,klauen,pl,null).                                % klauen ist ein Verb im Plural, ohne Argument und mit dem Label word_drei.


% Ein Satz besteht aus einer Nominalphrase NP und einer Verbalphrase VP.
% Diese NP hat einen Numerus und steht im Nominativ (nom),
% die VP hat ebenfalls einen Numerus und einen nicht vorgegebenen Fall. Der
% Numerus von NP und VP muss kongruent sein.
satz_drei(seq(NP,VP)):-                                        % Ein Satz besteht aus einer NP und einer VP
    np(NP,NUM,nom),                                            % Die NP besteht aus einer NP mit einem beliebigen Numerus im Nominativ und
    vp(VP,NUM,CASE).                                           % die VP hat den gleichen Numerus wie die NP und einem beliebigen Kasus.

% Die NP besteht aus einer Sequenz aus Determinierer und Nomen, die den selben
% Numerus, Genus und Kasus haben muessen.
% Beispiel: np(seq(die, katze),sg,nom) :-
%               word_drei(determiner, die, sg, fem, nom),
%               word_drei(noun, katze, dg, fem, nom).
np(seq(DET,NOUN),NUM,CASE):-                                   % Eine NP besteht aus einem Determiner und Nomen, die im Numerus und Kasus übereinstimmen und
    word_drei(determiner,DET,NUM,GEN,CASE),                    % der Determiner hat einen Numerus, Genus und Kasus und
    word_drei(noun,NOUN,NUM,GEN,CASE).                         % das Nomen hat den gleichen Numerus, Genus und Kasus wie der Determiner.

% Eine NP im Plural braucht keinen Determinierer.
% Beispiel: np(seq(katzen,pl,fem) :-
%               word_drei(noun,katzen,pl,fem,nom).
np(seq(NOUN),pl,CASE):-                                        % Eine NP im Plural hat einen beliebigen Kasus
    word_drei(noun,NOUN,pl,_GEN,CASE).                         % das Nomen steht im Plural mit beliebigem Genus und Kasus


% Eine VP besteht entweder aus einem Verb und einer NP, wobei der Kasus der NP
% von dem Verb bestimmt wird (transitive VP) ...
% Beispiel: vp(seq(jagt, NP),sg,acc) :-
%               word_drei(verb,jagt,sg,acc),
%               np(seq(die,katzen),pl,acc).
vp(seq(VERB,NP),NUM,CASE):-                                    % Eine VP besteht aus einem Verb und einer NP mit beliebigem Numerus, aber von der VP abhängigen Kasus
    word_drei(verb,VERB,NUM,CASE),                             % das Verb hat einen Numerus und Kasus
    np(NP,NUM2,CASE).                                          % die NP hat einen beliebigen Numerus und VP abhängigem Kasus

% ... oder nur aus einem Verb (intransitive VP).
% Beispiel: vp(seq(klaut),sg,null) :-
%               word_drei(verb,klaut,sg,null).
vp(seq(VERB),NUM,null):-                                       % Eine VP besteht aus einem Verb ohne Argument
    word_drei(verb,VERB,NUM,null).                             % Das Verb hat einen beliebigen Numerus ohne Argument
