%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                       %
% Zusatzaufgabe: Kreuzworträtsel        %
%                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% word/1 + |word|
% word(word, characters...)
% Representing a lexicon containing these words.
word(pluto, p,l,u,t,o).                                 % Das Wort Pluto besteht aus den einzelnen Buchstaben p, l, u, t, und o.
word(mars, m,a,r,s).                                    % Das Wort Mars besteht aus den einzelnen Buchstaben m, a, r, und s.
word(mond, m,o,n,d).                                    % Das Wort Mond besteht aus den einzelnen Buchstaben m, o, n und d.
word(saturn, s,a,t,u,r,n).                              % Das Wort Saturn besteht aus den einzelnen Buchstaben s, a, t, u, r und n.
word(apollo, a,p,o,l,l,o).                              % Das Wort Apollo besteht aus den einzelnen Buchstaben a, p, o, l, l und o.

% Tipps:
% Achte darauf, dass die Wörter sich an den richtigen Stellen überschneiden.
% Nutze _ (die anonyme Variable) an Stellen, an denen sich die Buchstaben nicht überschneiden. 


%%% Lösung:

% solve/5
% solve(Word1, ..., Word5)
solve(W1, W2, W3, W4, W5) :-                            % Das Kreuzworträtsel mit 5 Wörtern lässt sich dadurch lösen, wenn
    word(W1, _, X1, _, _, X2),                          % Wort 1 an zweiter Stelle X1 und an fünfter Stelle X2,                                
    word(W2, _, _, _, X1, _, _),                        % Wort 2 an vierter Stelle X1,
    word(W3, X3, _, X4, _),                             % Wort 3 an erster Stelle X3 und an vierter Stelle X4,
    word(W4, X3, X2, _, _),                             % Wort 4 an erster Stelle X3 und zweiter Stelle X2 und
    word(W5, _, _, _, _, X4, _).                        % Wort 5 an fünfter Stelle X4 hat.


% ?- solve(W1, W2, W3, W4, W5).
% -> W1 = pluto, 
% -> W2 = apollo, 
% -> W3 = mars, 
% -> W4 = mond, 
% -> W5 = saturn;
