%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                              %
% Rechteckaufgabe                                                              %
% Formuliere eine Anfrage zu dieser Wissensbasis, mit der die                  %
% fehlenden Eckkoordinaten dieses Rechtecks berechnet werden.                  %
% Das zu berechnende Rechteck befindet sich auf den Folien.                    %               
%                                                                              %
% vertical(line(point(X,_Y),point(X,_Z))).    % Eine vertikale Linie,          %
% die durch die Punkte X und _Y, X und _Z definiert ist.                       %
% horizontal(line(point(_X,Y),point(_Z,Y))).  % Eine horizontale Linie,        %                  
% die durch die Punkte _X und Y, sowie _Z und Y definiert ist.                 %
%                                                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Loesung

% Beispielanfrage:

% ?- vertical(line(point(1,1),LO)),horizontal(line(LO,point(6,3))),vertical(line(RU,point(6,3))),horizontal(line(point(1,1),RU)).

% Das Praedikat rechteck/4, mit dem man, wenn es in der Wissensbasis steht,
% ebenfalls die vier Ecken des Rechtecks berechnen kann

rechteck(OL,OR,UL,UR):-                                        % Ein Rechteck lässt sich mithilfe von OL, OR, UL und UR berechnen, wenn
         vertical(line(UL,OL)),                                % es eine vertikale Linie zwischen UL und OL und 
         vertical(line(UR,OR)),                                % eine zweite vertikale Linie zwischen UR und OR,
         horizontal(line(OL,OR)),                              % sowie eine horizontale Linie zwischen OL und OR und
         horizontal(line(UL,UR)).                              % eine zweite horizontale Linie zwischen UL und UR gibt.


% point/2
% point(X, Y): gibt die X-Koordinate und Y-Koordinate eines Punktes an
point(_, _).


% line/2
% line(X, Y): gibt die Linie zwischen einem X-Punkt und einem Y-Punkt an
line(_, _).


% vertical/1
% vertical(X): Überprüft ob die X-Werte der Punkte identisch sind
vertical(line(point(X, _),point(X, _))).


% horizontal/1
% horizontal(X): Überprüft ob die Y-Werte der Punkte identisch sind
horizontal(line(point(_, Y),point(_, Y))).

% IDEA: vertical(line( point(1,1), P )), horizontal(line( point(6,3), P )).
% IDEA: horizontal(line( point(1,1), P )), vertical(line( point(6,3), P )).


% edges/3
% edges(P1, P2, PQ): Berechnet, falls vorhanden, die vertikalen und horizontalen Eckpunkte
edges(P1, P2, PQ) :- vertical(line( P1, PQ )), horizontal(line( P2, PQ )).       % Es gibt einen Eckpunkt mit P1, P2 und PQ, wenn es eine vertikale Linie 
                                                                                 % von P1 zu PQ und eine horizontale Linie zwischen P2 und PQ gibt.
edges(P1, P2, PQ) :- horizontal(line( P1, PQ )), vertical(line( P2, PQ )).       % Es gibt einen Eckpunkt mit P1, P2 und PQ, wenn es eine horizontale Linie 
                                                                                 % von P1 zu Pq und eine vertikale Linie zwischen P2 und PQ gibt.

% IDEA: edges(point(1,1), point(6,3), PE).
